## libexecs 1.3

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.12)
project(s2argv-execs
    VERSION 1.3
    DESCRIPTION "execute a file taking its arguments from a string"
    HOMEPAGE_URL "https://github.com/rd235/s2argv-execs"
    LANGUAGES C)

set(LIB_VERSION 0.9.0)
set(LIB_SOVERSION 0)

include(GNUInstallDirs)
set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -Wall -pedantic")

include_directories(${CMAKE_CURRENT_SOURCE_DIR})

add_library(execs SHARED execs.c noshell.c)
set_target_properties(execs PROPERTIES VERSION ${LIB_VERSION}
        SOVERSION ${LIB_SOVERSION})

add_library(execs-embedded SHARED execs.c)
target_compile_options(execs-embedded PUBLIC -DEEXECS)
set_target_properties(execs-embedded PROPERTIES VERSION ${LIB_VERSION}
        SOVERSION ${LIB_SOVERSION})

add_library(execs_static STATIC execs.c noshell.c)
set_target_properties(execs_static PROPERTIES OUTPUT_NAME execs)

add_library(execs-embedded_static STATIC execs.c)
set_target_properties(execs-embedded_static PROPERTIES OUTPUT_NAME execs-embedded)
target_compile_options(execs-embedded_static PUBLIC -DEEXECS)

install(TARGETS execs LIBRARY DESTINATION ${CMAKE_INSTALL_LIBDIR})
install(TARGETS execs-embedded LIBRARY DESTINATION ${CMAKE_INSTALL_LIBDIR})
install(TARGETS execs_static LIBRARY DESTINATION ${CMAKE_INSTALL_LIBDIR})
install(TARGETS execs-embedded_static LIBRARY DESTINATION ${CMAKE_INSTALL_LIBDIR})
install(FILES execs.h DESTINATION ${CMAKE_INSTALL_INCLUDEDIR})

add_executable(exectest execstest.c)
target_link_libraries(exectest execs)

add_subdirectory(man)

add_custom_target(uninstall
  "${CMAKE_COMMAND}" -P "${PROJECT_SOURCE_DIR}/Uninstall.cmake")

=== man/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.7)

set(RONN_ORGANIZATION "VirtualSquare")
set(RONN_ARGS --organization=${RONN_ORGANIZATION})

# ### ronn pages

file(GLOB VU_RONN_PAGES ${CMAKE_CURRENT_SOURCE_DIR}/*.[1-8].ronn)
set(VU_MAN_FILES)
foreach(VU_RONN_PATH IN LISTS VU_RONN_PAGES)
# VU_RONNPAGE: basename of VU_RONN_PATH
	get_filename_component(VU_RONNPAGE ${VU_RONN_PATH} NAME)
# VU_MANPAGE: VU_RONNPAGE without the suffix
	string(REGEX REPLACE "\.ronn$" "" VU_MANPAGE ${VU_RONNPAGE})
	list(APPEND VU_MAN_FILES ${VU_MANPAGE})
endforeach(VU_RONN_PATH)

add_custom_target(${PROJECT_NAME}_manpages ALL make RONN_ARGS="${RONN_ARGS}"  ${VU_MAN_FILES}
	WORKING_DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR})

### man pages
file(GLOB VU_MAN_PAGES ${CMAKE_CURRENT_SOURCE_DIR}/*.[1-8])
foreach(VU_MAN_PATH IN LISTS VU_MAN_PAGES)
	get_filename_component(VU_MANPAGE ${VU_MAN_PATH} NAME)
	string(REGEX REPLACE ".*\\." "" MAN_CHAPTER ${VU_MANPAGE})
	install(FILES ${VU_MAN_PATH} DESTINATION ${CMAKE_INSTALL_MANDIR}/man${MAN_CHAPTER})
endforeach(VU_MAN_PATH)

## libexecs 1.1

=== debian/control ===
Source: libexecs
Priority: optional
Maintainer: Giulia Cantini <giuliacantini3@gmail.com>
Build-Depends: debhelper (>= 9), autotools-dev, dh-autoreconf
Standards-Version: 4.1.1
Section: libs
Vcs-Git: https://github.com/rd235/s2argv-execs

Package: libexecs-dev
Section: libdevel
Architecture: any
Depends: libexecs0 (= ${binary:Version}), libexecs-embedded0 (=${binary:Version}), ${misc:Depends}
Description: C library for commands execution - development files
 s2argv converts a command string into an argv array for execv, execvp,
 execvpe. execs is like execv taking a string instead of an argv.
 Similarly execsp and execspe are the counterpart of execvp and execvpe,
 respectively, using command strings.
 coprocv, coprocvp, coprocvpe, coprocs, coprocsp execute a command in
 coprocessing mode.
 The following functions all work without using a shell:
 esystem, system_eexecsp execute a command with its arguments from a string.
 popen_nosh, popen_execsp and pclose_nosh pipe stream to or from a process.
 system_nosh executes a command with its arguments from a string.
 .
 This package contains the necessary headers and shared object files needed to
 develop applications using libexecs.

Package: libexecs0
Section: libs
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: C library for commands execution
 s2argv converts a command string into an argv array for execv, execvp,
 execvpe. execs is like execv taking a string instead of an argv.
 Similarly execsp and execspe are the counterpart of execvp and execvpe,
 respectively, using command strings.
 coprocv, coprocvp, coprocvpe, coprocs, coprocsp execute a command in
 coprocessing mode.
 The following functions all work without using a shell:
 esystem, system_eexecsp execute a command with its arguments from a string.
 popen_nosh, popen_execsp and pclose_nosh pipe stream to or from a process.
 system_nosh executes a command with its arguments from a string.

Package: libexecs-embedded0
Section: libs
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: C library for commands execution
 s2argv converts a command string into an argv array for execv, execvp,
 execvpe. execs is like execv taking a string instead of an argv.
 Similarly execsp and execspe are the counterpart of execvp and execvpe,
 respectively, using command strings.
 esystem, system_eexecsp execute a command with its arguments from a string
 without using a shell.
 .
 This is the reduced memory footprint version of libexecs for embedded systems,
 it contains a minimal subset of the functionalities available in the
 main package, in particular the coproc* family of functions,
 system_nosh and popen_nosh are excluded (see the man pages for more info).

## libexecs 1.2

=== debian/changelog ===
libexecs (1.2-1) unstable; urgency=medium

  * new tag 1.2.
  * fix management of debian packaging on git

 -- Renzo Davoli <renzo@cs.unibo.it>  Sat, 05 Jan 2019 14:43:54 +0100

libexecs (1.1-1) unstable; urgency=medium

  * New upstream release. (Closes: #873675) 
  * Update Standards-Version to 4.0.0.
  * Add missing dependency in libexecs-dev. (Closes: #875421)

 -- Giulia Cantini <giuliacantini3@gmail.com>  Sat, 14 Oct 2017 18:00:04 +0200

libexecs (1.0-1) unstable; urgency=low

  * Initial release. (Closes: #859737)

 -- Giulia Cantini <giuliacantini3@gmail.com>  Mon, 13 Mar 2017 17:00:52 +0100

=== debian/control ===
--- 
+++ 
@@ -2,7 +2,7 @@
 Priority: optional
 Maintainer: Giulia Cantini <giuliacantini3@gmail.com>
 Build-Depends: debhelper (>= 9), autotools-dev, dh-autoreconf
-Standards-Version: 4.1.1
+Standards-Version: 4.0.0
 Section: libs
 Vcs-Git: https://github.com/rd235/s2argv-execs
 
@@ -26,7 +26,7 @@
  develop applications using libexecs.
 
 Package: libexecs0
-Section: libs
+Section: devel
 Architecture: any
 Depends: ${shlibs:Depends}, ${misc:Depends}
 Description: C library for commands execution
@@ -42,7 +42,7 @@
  system_nosh executes a command with its arguments from a string.
 
 Package: libexecs-embedded0
-Section: libs
+Section: devel
 Architecture: any
 Depends: ${shlibs:Depends}, ${misc:Depends}
 Description: C library for commands execution

=== debian/rules ===
#!/usr/bin/make -f
# See debhelper(7) (uncomment to enable)
# output every command that modifies files on the build system.
#export DH_VERBOSE = 1


# see FEATURE AREAS in dpkg-buildflags(1)
#export DEB_BUILD_MAINT_OPTIONS = hardening=+all

# see ENVIRONMENT in dpkg-buildflags(1)
# package maintainers to append CFLAGS
#export DEB_CFLAGS_MAINT_APPEND  = -Wall -pedantic
# package maintainers to append LDFLAGS
#export DEB_LDFLAGS_MAINT_APPEND = -Wl,--as-needed


%:
	dh $@ --with autotools_dev,autoreconf

# dh_make generated override targets
override_dh_auto_configure:
	dh_auto_configure -- --prefix=/usr

## libexecs 1.3

=== debian/changelog ===
libexecs (1.3-1) unstable; urgency=medium

  [ Renzo Davoli ]
  * new tag 1.3
  * use cmake instead of autotools
  * move maintenance within the Virtualsquare team
  * add watch file
  * bump debhelper compat level to 13

  [ Mattia Rizzolo ]
  * Mark all packages as Multi-Arch:same (from the m-a hinter).

  [ Andrea Capriotti ]
  * d/control: Bump Standard version to 4.5.1

 -- Andrea Capriotti <capriott@debian.org>  Mon, 18 Jan 2021 19:41:36 +0100

=== debian/control ===
--- 
+++ 
@@ -1,15 +1,20 @@
 Source: libexecs
 Priority: optional
-Maintainer: Giulia Cantini <giuliacantini3@gmail.com>
-Build-Depends: debhelper (>= 9), autotools-dev, dh-autoreconf
-Standards-Version: 4.0.0
 Section: libs
-Vcs-Git: https://github.com/rd235/s2argv-execs
+Maintainer: Debian VirtualSquare Team <virtualsquare@cs.unibo.it>
+Uploaders: Giulia Cantini <giuliacantini3@gmail.com>, Mattia Biondi <mattiabiondi1@gmail.com>, Renzo Davoli <renzo@cs.unibo.it>, Andrea Capriotti <capriott@debian.org>
+Build-Depends: debhelper-compat (= 13), cmake (>= 3.13)
+Standards-Version: 4.5.1
+Rules-Requires-Root: no
+Homepage: http://www.virtualsquare.org/
+Vcs-Git: https://salsa.debian.org/virtualsquare-team/s2argv-execs.git
+Vcs-Browser: https://salsa.debian.org/virtualsquare-team/s2argv-execs
 
 Package: libexecs-dev
 Section: libdevel
 Architecture: any
-Depends: libexecs0 (= ${binary:Version}), libexecs-embedded0 (=${binary:Version}), ${misc:Depends}
+Multi-Arch: same
+Depends: libexecs0 (= ${binary:Version}), libexecs-embedded0 (=${binary:Version}), ${shlibs:Depends}, ${misc:Depends}
 Description: C library for commands execution - development files
  s2argv converts a command string into an argv array for execv, execvp,
  execvpe. execs is like execv taking a string instead of an argv.
@@ -26,8 +31,8 @@
  develop applications using libexecs.
 
 Package: libexecs0
-Section: devel
 Architecture: any
+Multi-Arch: same
 Depends: ${shlibs:Depends}, ${misc:Depends}
 Description: C library for commands execution
  s2argv converts a command string into an argv array for execv, execvp,
@@ -42,10 +47,10 @@
  system_nosh executes a command with its arguments from a string.
 
 Package: libexecs-embedded0
-Section: devel
 Architecture: any
+Multi-Arch: same
 Depends: ${shlibs:Depends}, ${misc:Depends}
-Description: C library for commands execution
+Description: C library for commands execution - low memory footprint
  s2argv converts a command string into an argv array for execv, execvp,
  execvpe. execs is like execv taking a string instead of an argv.
  Similarly execsp and execspe are the counterpart of execvp and execvpe,

=== debian/watch ===
version=4

opts="filenamemangle=s%(?:.*?)?v?(\d[\d.]*)\.tar\.gz%s2argv-execs-$1.tar.gz%" \
   https://github.com/virtualsquare/s2argv-execs/tags \
   (?:.*?/)?v?(\d[\d.]*)\.tar\.gz

## libexecs 1.4

=== CMakeLists.txt ===
--- 
+++ 
@@ -1,12 +1,12 @@
 cmake_minimum_required(VERSION 3.12)
 project(s2argv-execs
-    VERSION 1.3
+    VERSION 1.4
     DESCRIPTION "execute a file taking its arguments from a string"
     HOMEPAGE_URL "https://github.com/rd235/s2argv-execs"
     LANGUAGES C)
 
-set(LIB_VERSION 0.9.0)
-set(LIB_SOVERSION 0)
+set(LIB_VERSION 1.4.0)
+set(LIB_SOVERSION 1)
 
 include(GNUInstallDirs)
 set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -Wall -pedantic")
@@ -31,8 +31,8 @@
 
 install(TARGETS execs LIBRARY DESTINATION ${CMAKE_INSTALL_LIBDIR})
 install(TARGETS execs-embedded LIBRARY DESTINATION ${CMAKE_INSTALL_LIBDIR})
-install(TARGETS execs_static LIBRARY DESTINATION ${CMAKE_INSTALL_LIBDIR})
-install(TARGETS execs-embedded_static LIBRARY DESTINATION ${CMAKE_INSTALL_LIBDIR})
+install(TARGETS execs_static ARCHIVE DESTINATION ${CMAKE_INSTALL_LIBDIR})
+install(TARGETS execs-embedded_static ARCHIVE DESTINATION ${CMAKE_INSTALL_LIBDIR})
 install(FILES execs.h DESTINATION ${CMAKE_INSTALL_INCLUDEDIR})
 
 add_executable(exectest execstest.c)

=== man/Makefile ===
PANDOC=pandoc
PANDOCOK := $(shell command -v ${PANDOC} 2> /dev/null)

none:

% : %.md
ifdef PANDOCOK
# copy copyright notice
		grep "^\.\\\\\"" $< > $@ || true
# run pandoc
		$(eval SECTION := $(subst .,,$(suffix $@)))
		$(eval BASENAME := $(basename $@))
		$(eval TITLE := $(shell echo "${BASENAME}\(${SECTION}\)" | tr [:lower:] [:upper:]))
		$(eval HEADER := "$(shell man ${SECTION} intro | head -1 | sed -e 's/^[^[:blank:]]*[[:blank:]]*//' -e 's/[[:blank:]]*[^[:blank:]]*$$//' )")
		$(PANDOC) -standalone -M title=${TITLE} -M section=${SECTION} -M header=${HEADER} -M footer=${PANDOC_ORG} -M "date=`date +\"%B %Y\"`" --to man $< >> $@
else
		echo "${PANDOC} is not available. Manpage $@ cannot be updated" >/dev/stderr >&2
endif

=== debian/changelog ===
libexecs (1.4-2) unstable; urgency=medium

  * Team upload.
  * Upload to unstable.

 -- Mattia Rizzolo <mattia@debian.org>  Sat, 01 Jul 2023 10:27:25 +0200

libexecs (1.4-1) experimental; urgency=medium

  * New upstream version 1.4.
  * Change library package names following bump in SONAME.

 -- Renzo Davoli <renzo@cs.unibo.it>  Sun, 25 Jun 2023 16:31:52 +0200

libexecs (1.3-3) unstable; urgency=medium

  [ Renzo Davoli ]
  * Move the static libraries to the -dev package, instead of library package.
    + Add Breaks/Replaces against the previous version.
  * Bump Standards-Version to 4.6.2, no changes needed.

  [ Mattia Rizzolo ]
  * d/watch: drop filenamemangle rule.
  * d/rules: get rid of the base dh-make template that doesn't bring anything.

 -- Renzo Davoli <renzo@cs.unibo.it>  Sun, 25 Jun 2023 12:13:46 +0200

libexecs (1.3-2) unstable; urgency=medium

  [Debian Janitor]
  * Remove constraints unnecessary since buster:
    + Build-Depends: Drop versioned constraint on cmake.

  [Andrea Capriotti]
  * Bump Standards-Version to 4.6.1, no changes needed.
  * d/copyright: Update Debian copyright

 -- Andrea Capriotti <capriott@debian.org>  Sun, 14 Aug 2022 13:40:18 +0200

=== debian/control ===
--- 
+++ 
@@ -3,8 +3,8 @@
 Section: libs
 Maintainer: Debian VirtualSquare Team <virtualsquare@cs.unibo.it>
 Uploaders: Giulia Cantini <giuliacantini3@gmail.com>, Mattia Biondi <mattiabiondi1@gmail.com>, Renzo Davoli <renzo@cs.unibo.it>, Andrea Capriotti <capriott@debian.org>
-Build-Depends: debhelper-compat (= 13), cmake (>= 3.13)
-Standards-Version: 4.5.1
+Build-Depends: debhelper-compat (= 13), cmake
+Standards-Version: 4.6.2
 Rules-Requires-Root: no
 Homepage: http://www.virtualsquare.org/
 Vcs-Git: https://salsa.debian.org/virtualsquare-team/s2argv-execs.git
@@ -14,7 +14,9 @@
 Section: libdevel
 Architecture: any
 Multi-Arch: same
-Depends: libexecs0 (= ${binary:Version}), libexecs-embedded0 (=${binary:Version}), ${shlibs:Depends}, ${misc:Depends}
+Depends: libexecs1 (= ${binary:Version}), libexecs-embedded1 (=${binary:Version}), ${misc:Depends}
+Breaks: libexecs0 (<< 1.3-3), libexecs-embedded0 (<< 1.3-3)
+Replaces: libexecs0 (<< 1.3-3), libexecs-embedded0 (<< 1.3-3)
 Description: C library for commands execution - development files
  s2argv converts a command string into an argv array for execv, execvp,
  execvpe. execs is like execv taking a string instead of an argv.
@@ -30,7 +32,7 @@
  This package contains the necessary headers and shared object files needed to
  develop applications using libexecs.
 
-Package: libexecs0
+Package: libexecs1
 Architecture: any
 Multi-Arch: same
 Depends: ${shlibs:Depends}, ${misc:Depends}
@@ -46,7 +48,7 @@
  popen_nosh, popen_execsp and pclose_nosh pipe stream to or from a process.
  system_nosh executes a command with its arguments from a string.
 
-Package: libexecs-embedded0
+Package: libexecs-embedded1
 Architecture: any
 Multi-Arch: same
 Depends: ${shlibs:Depends}, ${misc:Depends}

=== debian/watch ===
version=4

https://github.com/virtualsquare/s2argv-execs/tags \
   (?:.*?/)?v?(\d[\d.]*)\.tar\.gz
